#ifndef _EDITWING_IP_VIEW_H_
#define _EDITWING_IP_VIEW_H_
#include "ewView.h"
#include "ip_doc.h"
using namespace ki;
#ifndef __ccdoc__
namespace editwing {
namespace view {
#endif



using doc::DocImpl;



//=========================================================================
//@{ @pkg editwing.View.Impl //@}
//@{
//	`{[`
//
//	pɂ́ACanvasIuWFNg getPainter Ďg܂B
//	ʗpfoCXReLXg̃CłBƏĂΈ@\
//	ǉƂɊyȂ̂܂񂪁AȂƂlv搫
//	͂Ȃɂ߂ēKɁcB
//@}
//=========================================================================

class Painter : public Object
{
public:

	~Painter();

	//@{ wʒuɈꕶo //@}
	void CharOut( unicode ch, int x, int y );

	//@{ wʒuɕo //@}
	void StringOut( const unicode* str, int len, int x, int y );

	//@{ F؂ւ //@}
	void SetColor( int i );

	//@{ wiFœhԂ //@}
	void Fill( const RECT& rc );

	//@{ ] //@}
	void Invert( const RECT& rc );

	//@{  //@}
	void DrawLine( int x1, int y1, int x2, int y2 );

	//@{ Nbv̈ݒ //@}
	void SetClip( const RECT& rc );

	//@{ Nbv̈ //@}
	void ClearClip();

	//@{ pXy[XpL` //@}
	void DrawHSP( int x, int y, int times );

	//@{ SpXy[XpL` //@}
	void DrawZSP( int x, int y, int times );

public:

	//@{ (pixel) //@}
	int H() const { return height_; }

	//@{ (pixel) //@}
	int F() const { return figWidth_; }

	//@{ (pixel) //@}
	int Wc( unicode ch ) const
		{
			if( widthTable_[ ch ] == -1 )
				::GetCharWidthW( dc_, ch, ch, widthTable_+ch );
			return widthTable_[ ch ];
		}
	int W( const unicode* pch ) const // 1.08 TQ[gyA
		{
			unicode ch = *pch;
			if( widthTable_[ ch ] == -1 )
			{
				if( isHighSurrogate(ch) )
				{
					SIZE sz;
					if( ::GetTextExtentPoint32W( dc_, pch, 2, &sz ) )
						return sz.cx;
					int w = 0;
					::GetCharWidthW( dc_, ch, ch, &w );
					return w;
				}
				::GetCharWidthW( dc_, ch, ch, widthTable_+ch );
			}
			return widthTable_[ ch ];
		}

	//@{ W(pixel) //@}
	int W() const { return widthTable_[ L'x' ]; }

	//@{ ̃^uʒuvZ //@}
	//int nextTab(int x) const { int t=T(); return (x/t+1)*t; }
	int nextTab(int x) const { int t=T(); return ((x+4)/t+1)*t; }
	private: int T() const { return widthTable_[ L'\t' ]; } public:

	//@{ ݂̃tHg //@}
	const LOGFONT& LogFont() const { return logfont_; }

	//@{ ʕ`悷邩ۂ //@}
	bool sc( int i ) const { return scDraw_[i]; }

private:

	const HDC    dc_;
	const HFONT  font_;
	const HPEN   pen_;
	const HBRUSH brush_;
	int          height_;
	int*         widthTable_;
	int          figWidth_;
	LOGFONT      logfont_;
	COLORREF     colorTable_[7];
	bool         scDraw_[5];

private:

	Painter( HDC hdc, const VConfig& vc );
	HDC getDC() { return dc_; }
	friend class Canvas;
	NOCOPY(Painter);
};



//=========================================================================
//@{
//	`\̈
//
//	EChETCY̕ύX܂Ԃ̗LtHg̐ݒȂǂ
//	ΉāA`̈̃TCYKɊǗ܂B邱Ƃ
//	Ƃ肠ꂾB
//@}
//=========================================================================

class Canvas : public Object
{
public:

	Canvas( const View& vw );

	//@{ View̑傫ύXCxg
	//	 @return ܂Ԃςtrue //@}
	bool on_view_resize( int cx, int cy );

	//@{ sύXCxg
	//	 @return eLXg̈̕ςtrue //@}
	bool on_tln_change( ulong tln );

	//@{ tHgύXCxg //@}
	void on_font_change( const VConfig& vc );

	//@{ ݒύXCxg //@}
	void on_config_change( int wrap, bool showln );

public:

	//@{ [sԍ\邩ۂ] //@}
	bool showLN() const { return showLN_; }

	//@{ [-1:܂Ԃ  0:E[  else:w蕶] //@}
	int wrapType() const { return wrapType_; }

	//@{ ܂Ԃ(pixel) //@}
	ulong wrapWidth() const { return wrapWidth_; }

	//@{ \̈̈ʒu(pixel) //@}
	const RECT& zone() const { return txtZone_; }

	//@{ `pIuWFNg //@}
	Painter& getPainter() const { return *font_; }

private:

	int  wrapType_;  // [ -1:܂Ԃ  0:E[  else:w蕶 ]
	bool showLN_;    // [ sԍ\邩ۂ ]

	dptr<Painter> font_; // `pIuWFNg
	ulong    wrapWidth_; // ܂Ԃ(pixel)
	RECT       txtZone_; // eLXg\̈ʒu(pixel)
	int         figNum_; // sԍ̌

private:

	bool CalcLNAreaWidth();
	void CalcWrapWidth();

private:

	NOCOPY(Canvas);
};



//=========================================================================
//@{
//	s̐܂Ԃ
//@}
//=========================================================================

struct WLine : public storage<ulong>
{
	// [0]   : ̍s̐܂Ԃł̉i[
	// [1-n] : nsڂ̏I[indexi[B
	//
	//   Ⴆ "aaabbb" Ƃ_s "aaab" "bb" Ɛ܂Ȃ
	//   {48, 4, 6} ȂǂƂR̔zƂȂB

	WLine() : storage<ulong>(2) {}
	ulong& width()      { return (*this)[0]; }
	ulong width() const { return (*this)[0]; }
	ulong rln() const   { return size()-1; }
};



//=========================================================================
//@{
//	ĕ`͈͂w肷邽߂̃tO
//@}
//=========================================================================

enum ReDrawType
{
	LNAREA, // sԍ][̂
	LINE,   // ύX̂ŝ
	AFTER,  // ύX̂sȉS
	ALL     // S
};



//=========================================================================
//@{
//	`揈ׂw肷\
//@}
//=========================================================================

struct VDrawInfo
{
	const RECT rc;  // ĕ`͈
	int XBASE;      // ԍ̕xW
	int XMIN;       // eLXgĕ`͈͍[
	int XMAX;       // eLXgĕ`͈͉E[
	int YMIN;       // eLXgĕ`͈͏[
	int YMAX;       // eLXgĕ`͈͉[
	ulong TLMIN;    // eLXgĕ`͈͏[_sԍ
	int SXB, SXE;   // I͈͂xW
	int SYB, SYE;   // I͈͂yW

	explicit VDrawInfo( const RECT& r ) : rc(r) {}
};



//=========================================================================
//@{
//	܂ԂedeLXg̊ǗE\
//
//	CanvasNXɂČvZꂽ̈TCYQlɁAeLXg
//	܂ԂsBŁAXN[A`揈Ȃ
//	vȏ͑SĎs邱ƂɂȂB
//@}
//=========================================================================

class ViewImpl : public Object
{
public:

	ViewImpl( View& vw, DocImpl& dc );

	//@{ ܂Ԃؑ //@}
	void SetWrapType( int wt );

	//@{ sԍ\/\ؑ //@}
	void ShowLineNo( bool show );

	//@{ \FEtHgؑ //@}
	void SetFont( const VConfig& vc );

		//@{ eLXg̈̃TCYύXCxg //@}
		void on_view_resize( int cx, int cy );

	void DoResize( bool wrapWidthChanged );
	void DoConfigChange();

	//@{ eLXgf[^̍XVCxg //@}
	void on_text_update( const DPos& s,
		const DPos& e, const DPos& e2, bool bAft, bool mCur );

	//@{ `揈 //@}
	void on_paint( const PAINTSTRUCT& ps );

public:

	//@{ S\s //@}
	ulong vln() const { return vlNum_; }

	//@{ s̕\s //@}
	ulong rln( ulong tl ) const { return wrap_[tl].rln(); }

	//@{ ܂Ԃʒu //@}
	ulong rlend( ulong tl, ulong rl ) const { return wrap_[tl][rl+1]; }

	//@{ ł܂Ԃ݂邩ۂ //@}
	bool wrapexists() const { return doc_.tln() != vln(); }

	//@{ J[\ //@}
	Cursor& cur() { return cur_; }

	//@{ tHg //@}
	const Painter& fnt() const { return cvs_.getPainter(); }


	void on_hscroll( int code );
	void on_vscroll( int code );
	void on_wheel( short delta );

	void GetVPos( int x, int y, VPos* vp, bool linemode=false ) const;
	void GetOrigin( int* x, int* y ) const;
	void ConvDPosToVPos( DPos dp, VPos* vp, const VPos* base=NULL ) const;
	void ScrollTo( const VPos& vp );
	int  GetLastWidth( ulong tl ) const;

public:

	const RECT& zone() const { return cvs_.zone(); }
	int left()  const { return cvs_.zone().left; }
	int right() const { return cvs_.zone().right; }
	int bottom()const { return cvs_.zone().bottom; }
	int lna()   const { return cvs_.zone().left; }
	int cx()    const { return cvs_.zone().right - cvs_.zone().left; }
	int cxAll() const { return cvs_.zone().right; }
	int cy()    const { return cvs_.zone().bottom; }

private:

	const DocImpl&   doc_;
	Canvas           cvs_;
	Cursor           cur_;
	gapbufobj<WLine> wrap_;
	ulong            vlNum_;
	ulong            textCx_;

private:

	void DrawLNA( const VDrawInfo& v, Painter& p );
	void DrawTXT( const VDrawInfo v, Painter& p );
	void Inv( int y, int xb, int xe, Painter& p );

	void CalcEveryLineWidth();
	ulong CalcLineWidth( const unicode* txt, ulong len ) const;
	void ModifyWrapInfo( const unicode* txt, ulong len, WLine& wl, ulong stt );
	void ReWrapAll();
	int ReWrapSingle( const DPos& s );
	int InsertMulti( ulong ti_s, ulong ti_e );
	int DeleteMulti( ulong ti_s, ulong ti_e );
	void UpdateTextCx();
	void ReDraw( ReDrawType r, const DPos* s=NULL );

private:

	HWND hwnd_;
	SCROLLINFO rlScr_; // XN[ipixelPʁj
	SCROLLINFO udScr_; // cXN[isPʁj
	ulong udScr_tl_;   // ԏɕ\_sTLine_Index
	ulong udScr_vrl_;  // ԏɕ\\sVRLine_Index

private:

	bool ReSetScrollInfo();
	void ForceScrollTo( ulong tl );
	void UpdateScrollBar();
	ReDrawType TextUpdate_ScrollBar( const DPos& s, const DPos& e, const DPos& e2 );

	ulong tl2vl( ulong tl ) const;
	void GetDrawPosInfo( VDrawInfo& v ) const;
	void InvalidateView( const DPos& dp, bool afterall ) const;
	void ScrollView( int dx, int dy, bool update );
	void UpDown( int dy, bool thumb );
};



//-------------------------------------------------------------------------

inline void ViewImpl::on_view_resize( int cx, int cy )
	{ DoResize( cvs_.on_view_resize( cx, cy ) ); }

inline void ViewImpl::SetWrapType( int wt )
	{ cvs_.on_config_change( wt, cvs_.showLN() );
	  DoConfigChange(); }

inline void ViewImpl::ShowLineNo( bool show )
	{ cvs_.on_config_change( cvs_.wrapType(), show );
	  DoConfigChange(); }

inline void ViewImpl::SetFont( const VConfig& vc )
	{ cvs_.on_font_change( vc );
	  cur_.on_setfocus();
	  CalcEveryLineWidth(); // sČvZ
	  DoConfigChange(); }

inline void ViewImpl::GetOrigin( int* x, int* y ) const
	{ *x = left()-rlScr_.nPos, *y = -udScr_.nPos*cvs_.getPainter().H(); }



//=========================================================================

}}     // namespace editwing::view
#endif // _EDITWING_IP_VIEW_H_
