#include "stdafx.h"
#include "memory.h"
using namespace ki;



//=========================================================================

#ifdef SUPERTINY

	static HANDLE g_heap;

	#ifndef _DEBUG

		void* __cdecl operator new( size_t siz )
		{
			return ::HeapAlloc( g_heap, HEAP_GENERATE_EXCEPTIONS, siz );
		}

		void __cdecl operator delete( void* ptr )
		{
			::HeapFree( g_heap, 0, ptr );
		}

	#else

		// fobOpɉ񐔌v(^^;
		static int allocCounter = 0;
		void* __cdecl operator new( size_t siz )
		{
			++allocCounter;
			return ::HeapAlloc( g_heap, HEAP_GENERATE_EXCEPTIONS, siz );
		}
		void __cdecl operator delete( void* ptr )
		{
			::HeapFree( g_heap, 0, ptr );
			if( ptr != NULL )
				--allocCounter;
		}

	#endif

	extern "C"
	void* __cdecl memset( void* buf, int ch, size_t n )
	{
		BYTE v = BYTE(ch&0xff);
		BYTE* ptr = (BYTE*)buf;
		DWORD vvvv = (v<<24) | (v<<16) | (v<<8) | v;
		for(;n>3;n-=4,ptr+=4) *(DWORD*)ptr = vvvv;
		for(;n;--n,++ptr) *ptr = v;
		return buf;
	}

	void* __cdecl memmove( void* dst, const void* src, size_t cnt )
	{
		__asm {
			mov  esi, [src]    ;U  esi = const void* src
			mov  edx, [cnt]    ;V  edx =       void* cnt
			mov  edi, [dst]    ;U  edi =       ulong dst
			mov  ebx, edx      ;V
			mov  eax, 03h      ;U  eax = const ulong  3 (for masking)
			add  ebx, esi      ;V  ebx = const void* src+cnt

			cmp  edi, esi      ;
			jbe  CopyUp        ;
			cmp  edi, ebx      ;   if( src < dst < src+cnt )
			jb   CopyDown      ;     downward copy

		CopyUp:
			cmp  edx, eax      ;   if( cnt<=3 )
			jbe  MiniCopy      ;     byte by byte copy

			mov  ebx, edi      ;U
			mov  ecx, eax      ;V
			and  ebx, eax      ;U  ebx = (dst&3)
			inc  ecx           ;V
			sub  ecx, ebx      ;   ecx = (4-(dst&3))
			and  ecx, eax      ;   ecx = {dst%4 0->0 1->3 2->2 3->1}
			sub  edx, ecx      ;
			rep  movsb         ;N  BYTE MOVE (align dst)

			mov  ecx, edx      ;
			shr  ecx, 2        ;   ecx = [rest bytes]/4
			and  edx, eax      ;   edx = [rest bytes]%4
			rep  movsd         ;N  DWORD MOVE
			jmp  MiniCopy      ;

		CopyDown:
			std                  ;
			lea  esi,[esi+edx-1] ;
			lea  edi,[edi+edx-1] ;

			cmp  edx, 4        ;   if( cnt<=4 )
			jbe  MiniCopy      ;     byte by byte copy

			mov  ecx, edi      ;
			and  ecx, eax      ;
			inc  ecx           ;   ecx = {dst%4 0->1 1->2 2->3 3->4}
			sub  edx, ecx      ;
			rep  movsb         ;N  BYTE MOVE (align dst @ dword)

			sub  edi, eax      ;U
			mov  ecx, edx      ;V
			sub  esi, eax      ;U
			shr  ecx, 2        ;V  ecx = [rest bytes]/4
			and  edx, eax      ;   edx = [rest bytes]%4
			rep  movsd         ;N  DWORD MOVE
			add  edi, eax      ;U
			add  esi, eax      ;V

		MiniCopy:
			mov  ecx, edx      ;
			rep  movsb         ;N  BYTE MOVE

			cld                ;U
			mov  eax, [dst]    ;V  return dst
		}
		return dst;
	}

#endif



#ifdef USE_ORIGINAL_MEMMAN
//=========================================================================
//	IȃǗڎwAP[^
//=========================================================================

//
// ubN
// usizoCg * numv̗̈ꊇmۂ̂d
//
// 󂫃ubNɂ́A擪oCg [̋󂫃ubNindex] i[B
// pāA擪ւ̏ô݂\ȒPXgƂĈB
//

struct ki::MemBlock
{
public:
	void  Construct( byte siz, byte num );
	void  Destruct();
	void* Alloc( byte siz );
	void  DeAlloc( void* ptr, byte siz );
	bool  isAvail();
	bool  isEmpty( byte num );
	bool  hasThisPtr( void* ptr, size_t len );
private:
	byte* buf_;
	byte  first_, avail_;
};

void MemBlock::Construct( byte siz, byte num )
{
	// m
	buf_   = ::new byte[siz*num];
	first_ = 0;
	avail_ = num;

	// AXg
	for( byte i=0,*p=buf_; i<num; p+=siz )
		*p = ++i;
}

inline void MemBlock::Destruct()
{
	// 
	::delete [] buf_;
}

void* MemBlock::Alloc( byte siz )
{
	// ؂o
	//   ( avail==0 ̃`FbN͏ʑwɔC )
	byte* blk = buf_ + siz*first_;
	first_    = *blk;
	--avail_;
	return blk;
}

void MemBlock::DeAlloc( void* ptr, byte siz )
{
	// ߂
	//   ( ςȃ|C^nꂽ炾`߁` )
	byte* blk = static_cast<byte*>(ptr);
	*blk      = first_;
	first_    = static_cast<byte>((blk-buf_)/siz);
	++avail_;
}

inline bool MemBlock::isAvail()
{
	// 󂫂H
	return (avail_ != 0);
}

inline bool MemBlock::isEmpty( byte num )
{
	// SɋH
	return (avail_ == num);
}

inline bool MemBlock::hasThisPtr( void* ptr, size_t len )
{
	// ̃ubÑ|C^H
	return ( buf_<=ptr && ptr<buf_+len );
}



//-------------------------------------------------------------------------

//
// ŒTCYmېl
// usizoCgv̗̈𖈉mۂ̂d
//
// ubÑXgێA󂢂ĂubNg
// vɉĂB󂫂ȂȂVMemBlock
// ăXgɉB
//
// ŌɃ蓖/sBlockꂼLĂA
// ŏɂ𒲂ׂ邱Ƃō}B
//

void MemoryManager::FixedSizeMemBlockPool::Construct( byte siz )
{
	// }l[W܂ł́A
	// ʂauto_ptrgȂc
	struct AutoDeleter
	{
		AutoDeleter( MemBlock* p ) : ptr_(p) {}
		~AutoDeleter() { ::delete [] ptr_; }
		void Release() { ptr_ = NULL; }
		MemBlock* ptr_;
	};

	// ubN傱Ɗm
	AutoDeleter a( blocks_ = ::new MemBlock[4] );

	// ubNTCYvZ
	int npb = BLOCK_SIZ/siz;
	numPerBlock_ = static_cast<byte>( Min( npb, 255 ) );
	fixedSize_   = siz;

	// ubN쐬
	blocks_[0].Construct( fixedSize_, numPerBlock_ );

	a.Release();
	lastA_            = 0;
	lastDA_           = 0;
	blockNum_         = 1;
	blockNumReserved_ = 4;
}

void MemoryManager::FixedSizeMemBlockPool::Destruct()
{
	// eubN
	for( int i=0; i<blockNum_; ++i )
		blocks_[i].Destruct();

	// ubNێ̈̃
	::delete [] blocks_;
	blockNum_ = 0;
}

void* MemoryManager::FixedSizeMemBlockPool::Alloc()
{
	// lastA_Validǂ`FbNȂƂ܂B
	// DeAllocĂȂȂĂ邩Ȃ̂ŁB

	// O񃁃؂oubN
	// ܂󂫂邩ǂ`FbN
	if( !blocks_[lastA_].isAvail() )
	{
		// ꍇAXg̖珇ɐ`T
		for( int i=blockNum_;; )
		{
			if( blocks_[--i].isAvail() )
			{
				// 󂫃ubN`I
				lastA_ = i;
				break;
			}
			if( i == 0 )
			{
				// S܂Ă...
				if( blockNum_ == blockNumReserved_ )
				{
					// Ɨ̈tȂ̂Ŋg
					MemBlock* nb = ::new MemBlock[ blockNum_*2 ];
					memmove( nb, blocks_, sizeof(MemBlock)*(blockNum_) );
					::delete [] blocks_;
					blocks_ = nb;
					blockNumReserved_ *= 2;
				}

				// VubN\z
				blocks_[ blockNum_ ].Construct( fixedSize_, numPerBlock_ );
				lastA_ = blockNum_++;
				break;
			}
		}
	}

	// ubN؂o蓖
	return blocks_[lastA_].Alloc( fixedSize_ );
}

void MemoryManager::FixedSizeMemBlockPool::DeAlloc( void* ptr )
{
	// YubNT
	const int mx=blockNum_, ln=fixedSize_*numPerBlock_;
	for( int u=lastDA_, d=lastDA_-1;; )
	{
		if( u>=0 )
			if( blocks_[u].hasThisPtr(ptr,ln) )
			{
				lastDA_ = u;
				break;
			}
			else if( u==mx )
			{
				u = -1;
			}
			else
			{
				++u;
			}
		if( d>=0 )
			if( blocks_[d].hasThisPtr(ptr,ln) )
			{
				lastDA_ = d;
				break;
			}
			else
			{
				--d;
			}
	}

	// s
	blocks_[lastDA_].DeAlloc( ptr, fixedSize_ );

	// ̍폜ŃubNSɋɂȂꍇ
	if( blocks_[lastDA_].isEmpty( numPerBlock_ ) )
	{
		// Ԍ̃ubNłȂ
		int end = blockNum_-1;
		if( lastDA_ != end )
		{
			// Ԍ낪󂾂
			if( blocks_[end].isEmpty( numPerBlock_ ) )
			{
				blocks_[end].Destruct();
				--blockNum_;
				if( lastA_ > --end )
					lastA_ = end;
			}

			// ƌ
			MemBlock tmp( blocks_[lastDA_] );
			blocks_[lastDA_] = blocks_[end];
			blocks_[end]     = tmp;
		}
	}
}

inline bool MemoryManager::FixedSizeMemBlockPool::isValid()
{
	// ɎgpJnĂ邩H
	return (blockNum_ != 0);
}



//-------------------------------------------------------------------------

//
// ŏʑw
// wTCYɂ FixedSizeMemBlockPool ɏ܂킷
//
// loki̎ł͌ŒTCYAP[^AKvɉ
// ImۂĂA͖ʓ|Ȃ̂ł߂܂B(^^;
// ŏ64mۂƌāAȂɃȂcB
//

MemoryManager* MemoryManager::pUniqueInstance_;

MemoryManager::MemoryManager()
{
	g_heap = ::GetProcessHeap();

	// v[ZERONA
	mem00( pools_, sizeof(pools_) );

	// B̃CX^X͎ł
	pUniqueInstance_ = this;
}

MemoryManager::~MemoryManager()
{
	// \zς݃v[Sĉ
	for( int i=0; i<SMALL_MAX; ++i )
		if( pools_[i].isValid() )
			pools_[i].Destruct();

#if defined(SUPERTINY) && defined(_DEBUG)
	// [Nop
	if( allocCounter != 0 )
		::MessageBox( NULL, TEXT("MemoryLeak!"), NULL, MB_OK );
#endif
}


void* MemoryManager::Alloc( size_t siz )
{
#if defined(SUPERTINY) && defined(_DEBUG)
	++allocCounter;
#endif

	// TCY납傫Ȃ
	// ftHg new ZqɔC
	uint i = static_cast<uint>( siz-1 );
	if( i >= SMALL_MAX )
		return ::operator new( siz );

	// }`XbhΉ
	AutoLock al(this);

	// ̃TCỸmۂ߂ĂȂ
	// Ńv[쐬B
	if( !pools_[i].isValid() )
		pools_[i].Construct( static_cast<byte>(siz) );

	// Ŋ蓖
	return pools_[i].Alloc();
}

void MemoryManager::DeAlloc( void* ptr, size_t siz )
{
#if defined(SUPERTINY) && defined(_DEBUG)
	--allocCounter;
#endif

	// TCY납傫Ȃ
	// ftHg delete ZqɔC
	uint i = static_cast<uint>( siz-1 );
	if( i >= SMALL_MAX )
	{
		::operator delete( ptr );
		return; // VC return void oȂƂ́c
	}

	// }`XbhΉ
	AutoLock al(this);

	// ŉ
	pools_[i].DeAlloc( ptr );
}

#else // USE_ORIGNAL_MEMMAN

MemoryManager* MemoryManager::pUniqueInstance_;

MemoryManager::MemoryManager()
{
	g_heap = ::GetProcessHeap();

	// B̃CX^X͎ł
	pUniqueInstance_ = this;
}

MemoryManager::~MemoryManager()
{
#if defined(SUPERTINY) && defined(_DEBUG)
	// [Nop
	if( allocCounter != 0 )
		::MessageBox( NULL, TEXT("MemoryLeak!"), NULL, MB_OK );
#endif
}

void* MemoryManager::Alloc( size_t siz )
{
	return ::operator new(siz);
}

void MemoryManager::DeAlloc( void* ptr, size_t siz )
{
	::operator delete(ptr);
}

#endif
