#ifndef _KILIB_WINDOW_H_
#define _KILIB_WINDOW_H_
#include "types.h"
#include "memory.h"
#include "ktlaptr.h"
#ifndef __ccdoc__
namespace ki {
#endif



// ^CAEgtMsgBox̕Ԓl
#define IDTIMEOUT 0



//=========================================================================
//@{ @pkg ki.Window //@}
//@{
//	pNX
//
//	OA_CAORg[vpeBV[g
//	ʂ̃EChES܂Ƃ߂ċʂɈ߂̃C^[tFCXB
//	ۂ̎́AʃNX XxxImpl ōsĂB
//@}
//=========================================================================

class Window : public Object
{
public:

	//@{ CbZ[W[v //@}
	void MsgLoop();

	//@{ bZ[W𑗂ď܂őҋ@ //@}
	LRESULT SendMsg( UINT msg, WPARAM wp=0, LPARAM lp=0 );

	//@{ bZ[W𑗂ĂA //@}
	BOOL PostMsg( UINT msg, WPARAM wp=0, LPARAM lp=0 );

	//@{
	//	ŋ@\tbZ[W{bNX
	//	@param msg \镶
	//	@param caption _CAȎ薼
	//	@param type Win32SDK̐Ă
	//@}
	int MsgBox( LPCTSTR msg, LPCTSTR caption=NULL, UINT type=MB_OK ) const;

	//@{ eLXgݒ //@}
	void SetText( const TCHAR* str );

	//@{ \ //@}
	void ShowUp( int sw=SW_SHOW );

	//@{ ړ //@}
	void MoveTo( int l, int t, int r, int b );

	//@{ tH[JX //@}
	void SetFocus();

	//@{ őOʂGo! //@}
	void SetFront();

	//@{ ʒGo! //@}
	void SetCenter();

public:

	//@{ EChEnh //@}
	HWND hwnd() const;

	//@{ ʒuETCY //@}
	void getPos( RECT* rc ) const;

	//@{ TCY //@}
	void getClientRect( RECT* rc ) const;

	//@{ C[v񂵂ĂEChEǂ //@}
	bool isMainWnd() const;

	//@{ ĂH //@}
	bool isAlive() const;

public:

	//@{ bZ[WKɏ //@}
	static void ProcessMsg();

	//@{ őOʂGo! //@}
	static void SetFront( HWND hwnd );

	//@{
	//	ʒGo!
	//	@param hwnd EChE
	//	@param rel ɂEChE
	//@}
	static void SetCenter( HWND hwnd, HWND rel=NULL );

protected:

	// ȂRXgN^
	Window();

	// HwndZbg
	void SetHwnd( HWND wnd );

	// ANZ[^ʂƂ_CAObZ[W̏Ƃ
	virtual bool PreTranslateMessage( MSG* ) = 0;

private:

	HWND wnd_;
	bool isLooping_;

private:

	NOCOPY(Window);
};



//-------------------------------------------------------------------------
#ifndef __ccdoc__

inline LRESULT Window::SendMsg( UINT msg, WPARAM wp, LPARAM lp )
	{ return ::SendMessage( wnd_, msg, wp, lp ); }

inline BOOL Window::PostMsg( UINT msg, WPARAM wp, LPARAM lp )
	{ return ::PostMessage( wnd_, msg, wp, lp ); }

inline int Window::MsgBox( LPCTSTR m, LPCTSTR c, UINT y ) const
	{ return ::MessageBox( wnd_, m, c, y ); }

inline void Window::ShowUp( int sw )
	{ ::ShowWindow( wnd_, sw ), ::UpdateWindow( wnd_ ); }

inline void Window::SetText( const TCHAR* str )
	{ ::SetWindowText( wnd_, str ); }

inline void Window::MoveTo( int l, int t, int r, int b )
	{ ::MoveWindow( wnd_, l, t, r-l, b-t, TRUE ); }

inline void Window::SetFocus()
	{ ::SetFocus( wnd_ ); }

inline void Window::SetFront()
	{ SetFront( wnd_ ); }

inline void Window::SetCenter()
	{ SetCenter( wnd_ ); }

inline HWND Window::hwnd() const
	{ return wnd_; }

inline bool Window::isMainWnd() const
	{ return isLooping_; }

inline void Window::getPos( RECT* rc ) const
	{ ::GetWindowRect( wnd_, rc ); }

inline void Window::getClientRect( RECT* rc ) const
	{ ::GetClientRect( wnd_, rc ); }

inline bool Window::isAlive() const
	{ return FALSE != ::IsWindow( wnd_ ); }



#endif // __ccdoc__
//=========================================================================
//@{
//	IME}l[W
//
//	Global IME T|[gɂ́AEChEbZ[W̏
//	{IɓւKvBŁÃNXɂ܂Ƃ
//	WindowNXƘAgsƂŁACůO͈
//	Cɂł悤ɂĂBȂAGlobal IMEɑΉ
//	ɂ̓o[W̐VPlatform SDKKvȂ
//	}N USEGLOBALIME `ĂȂ΂̕ӂ͏ȂB
//@}
//=========================================================================

class IMEManager
{
public:

	//@{ tHgw //@}
	void SetFont( HWND wnd, const LOGFONT& lf );

	//@{ ʒuw //@}
	void SetPos( HWND wnd, int x, int y );

	//@{ m蕶QbgB󂯎 delete 邱ƁB //@}
	void GetString( HWND wnd, unicode** str, ulong* len );

	//@{ GlobalIME𗘗p\Ԃɂ //@}
	void EnableGlobalIME( bool enable );

	//@{ GlobalIMEgWindow̃Xgo^ //@}
	void FilterWindows( ATOM* lst, UINT siz );

private:

	IMEManager();
	~IMEManager();
	void    TranslateMsg( MSG* msg );
	LRESULT DefProc( HWND wnd, UINT msg, WPARAM wp, LPARAM lp );
	void    MsgLoopBegin();
	void    MsgLoopEnd();

private:

	#ifdef USEGLOBALIME
		IActiveIMMApp*              immApp_;
		IActiveIMMMessagePumpOwner* immMsg_;
	#endif
	static IMEManager* pUniqueInstance_;

private:

	friend class Window;
	friend class WndImpl;
	friend void APIENTRY  Startup();
	friend inline IMEManager& ime();
	NOCOPY(IMEManager);
};



//-------------------------------------------------------------------------

//@{ BIMEǗIuWFNgԂ //@}
inline IMEManager& ime()
	{ return *IMEManager::pUniqueInstance_; }



//=========================================================================
//@{
//	ʂ̃EChE
//
//	hNX`āARXgN^̈ WndImpl 
//	WNDCLASSX^CnAȂ WNDCLASS  Register
//	āAƂ͓Kȃ^C~O Create() ƂgzB
//
//	HWNDWndImpl*ւ̕ϊx86/x86-64p̃TNōsĂ܂B
//	̂ŁÃA[LeN`ł͂̂܂܂ł͓삵܂BڐA
//	ꍇ́AGWL_USERDATA gȂ clsExtra ɓȂ
//	ėp̂@ɓKXςĂB
//@}
//=========================================================================

class WndImpl : public Window
{
	enum { THUNK_SIZE = 22 };

public:

	//@{ EChE쐬 //@}
	bool Create( LPCTSTR wndName=NULL,      HWND parent=NULL,
	             int  x     =CW_USEDEFAULT, int y      =CW_USEDEFAULT,
	             int  width =CW_USEDEFAULT, int height =CW_USEDEFAULT,
	             void* param=NULL );

	//@{ EChEj //@}
	void Destroy();

protected:

	//@{
	//	RXgN^
	//	@param className EChENX
	//	@param style WX^C
	//	@param styleEx WgX^C
	//@}
	WndImpl( LPCTSTR className, DWORD style, DWORD styleEx=0 );
	~WndImpl();

	//@{ NXp̌^ //@}
	typedef const TCHAR* const ClsName;

	//@{ EChENXo^ //@}
	static ATOM Register( WNDCLASSEX* cls );

	// ĂƁ[ɎĔĂB
	// on_command́AȂfalseԂƁB
	// on_messagéAȂWndImpl::on_messageĂяoƁB
	// PreTranslateMessagéAĂȂĂŌĂяoƁB
	virtual void    on_create( CREATESTRUCT* cs );
	virtual void    on_destroy();
	virtual bool    on_command( UINT id, HWND ctrl );
	virtual LRESULT on_message( UINT msg, WPARAM wp, LPARAM lp );
	virtual bool    PreTranslateMessage( MSG* msg );

private:

	static LRESULT CALLBACK StartProc( HWND, UINT, WPARAM, LPARAM );
	static LRESULT CALLBACK MainProc( WndImpl*, UINT, WPARAM, LPARAM );
	void SetUpThunk( HWND wnd );

private:

	LPCTSTR     className_;
	const DWORD style_, styleEx_;
	byte*       thunk_;
};



//=========================================================================
//@{
//	_CAO
//
//	hNX`āARXgN^̈ DlgImpl 
//	\[XIDnA͓Kȃ^C~O GoModal Ȃ
//	Modeless ȂAƂgzB
//
//	HWNDDlgImpl*ւ̕ϊ GWL_USERDATA ōsĂ܂B
//	̂ŁA͎gȂ悤ɂ܂傤B
//@}
//=========================================================================

class DlgImpl : public Window
{
public:

	enum dlgtype { MODAL, MODELESS };

	//@{ [_Ŏs //@}
	void GoModal( HWND parent=NULL );

	//@{ [hXō쐬 //@}
	void GoModeless( HWND parent=NULL );

	//@{ IɏI点 //@}
	void End( UINT code );

public:

	//@{ [_[hX //@}
	dlgtype type() const;

	//@{ IR[h擾 //@}
	UINT endcode() const;

protected:

	//@{ RXgN^ //@}
	DlgImpl( UINT id );
	~DlgImpl();

	//@{ qACeIDHWNDϊ //@}
	HWND item( UINT id ) const;

	//@{ ACeɑ΂ăbZ[WM //@}
	LRESULT SendMsgToItem( UINT id, UINT msg, WPARAM wp=0, LPARAM lp=0 );

	//@{ ACeɑ΂ăbZ[WMi|C^Łj //@}
	LRESULT SendMsgToItem( UINT id, UINT msg, void* lp );

	//@{ ACeɑ΂ăbZ[WMi񑗂Łj //@}
	LRESULT SendMsgToItem( UINT id, UINT msg, const TCHAR* lp );

	// ĂƁ[ɎĔĂB
	// on_ok/on_canceĺAIėǂȂtrueԂƁB
	// on_cmd/on_msǵAς݂ȂtrueԂƁB
	virtual void on_init();
	virtual void on_destroy();
	virtual bool on_ok();
	virtual bool on_cancel();
	virtual bool on_command( UINT cmd, UINT id, HWND ctrl );
	virtual bool on_message( UINT msg, WPARAM wp, LPARAM lp );
	virtual bool PreTranslateMessage( MSG* msg );

private:

	static BOOL CALLBACK MainProc( HWND, UINT, WPARAM, LPARAM );

private:

	dlgtype    type_;
	UINT       endCode_;
	const UINT rsrcID_;
};



//-------------------------------------------------------------------------
#ifndef __ccdoc__

inline DlgImpl::dlgtype DlgImpl::type() const
	{ return type_; }

inline UINT DlgImpl::endcode() const
	{ return endCode_; }

inline HWND DlgImpl::item( UINT id ) const
	{ return ::GetDlgItem( hwnd(), id ); }

inline LRESULT DlgImpl::SendMsgToItem
	( UINT id, UINT msg, WPARAM wp, LPARAM lp )
	{ return ::SendDlgItemMessage( hwnd(), id, msg, wp, lp ); }

inline LRESULT DlgImpl::SendMsgToItem( UINT id, UINT msg, void* lp )
	{ return ::SendDlgItemMessage( hwnd(), id, msg, 0,
	                            reinterpret_cast<LPARAM>(lp) ); }

inline LRESULT DlgImpl::SendMsgToItem( UINT id, UINT msg, const TCHAR* lp )
	{ return ::SendDlgItemMessage( hwnd(), id, msg, 0,
	                            reinterpret_cast<LPARAM>(lp) ); }



//=========================================================================

#endif // __ccdoc__
}      // namespace ki
#endif // _KILIB_WINDOW_H_
